<?php
    $tables = \GCore\Libs\Database::getInstance()->getTablesList();
    array_unshift($tables, '');
    $tables = array_combine($tables, $tables);
    echo "<style type='text/css'>
      .gh_title {
        /*border-top: 3px solid silver;*/
        /*border-bottom: 1px solid silver;*/
        padding: 0;
        margin-bottom: 6px;
      } </style>";
    echo \GCore\Helpers\Html::formStart('action_config csv_export_action_config', 'csv_export_action_config__XNX_');
?>
    <ul class="nav nav-tabs">
      <li class="active"><a href="#enable-_XNX_" data-g-toggle="tab">Enable</a></li>
      <li><a href="#export_data-_XNX_" data-g-toggle="tab">Data</a></li>
      <li><a href="#export_file-_XNX_" data-g-toggle="tab">File</a></li>
      <li><a href="#download-_XNX_" data-g-toggle="tab">Download</a></li>
      <li><a href="#mysql-_XNX_" data-g-toggle="tab">MySQL</a></li>
      <li><a href="#columns-_XNX_" data-g-toggle="tab">Columns</a></li>
      <li><a href="#help-_XNX_" data-g-toggle="tab">Help</a></li>
      <li><a href="#changelog-_XNX_" data-g-toggle="tab">Changelog</a></li>
    </ul>
    <div class="tab-content">
      <div id="enable-_XNX_" class="tab-pane active">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    //echo "<div class='gh_title' ><p>Please scroll down for more options and help.</p></div>";
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][enabled]', array(
      'type'      => 'checkbox',
      'class'     => 'SSS',
      'label'     => l_('Enable this action') ,
      'sublabel'  => l_('Check this box to enable the action; uncheck to disable.')
    ));
/*    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][enabled]', array(
      'type'      => 'dropdown',
      'label'     => l_('CF_ENABLED') ,
      'options'   => array(
          0 => l_('NO') ,
          1 => l_('YES')
      )
    ));*/
    echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="export_data-_XNX_" class="tab-pane">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    echo "<div class='gh_title' ><h4>Data to be exported</h4></div>";
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][tablename]', array(
      'type'      => 'dropdown',
      'label'     => l_('CF_CSV_TABLENAME') ,
      'options'   => $tables,
      'sublabel'  => l_('CF_CSV_TABLENAME_DESC')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][tablename_dynamic]', array(
      'type'      => 'text',
      'class'     => 'M',
      'label'     => l_('Dynamic table name') ,
      'sublabel'  => l_('The form input name that will contain a table name for the export. If you use this option the entry above will be ignored. Note that any column name selection or WHERE settings need to match the table set here!')
    ));
        echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][data_path]', array(
      'type'      => 'text',
      'class'     => 'M',
      'label'     => l_('CF_CSV_DATA_PATH') ,
      'sublabel'  => l_('CF_CSV_DATA_PATH_DESC')
    ));
    echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="export_file-_XNX_" class="tab-pane">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    echo "<div class='gh_title' ><h4>Export file</h4></div>";
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][save_path]', array(
      'type'      => 'text',
      'class'     => 'M',
      'label'     => l_('Save path') ,
      'sublabel'  => l_('The path to the folder where the csv file will be saved<br />
e.g. /home/greyhead/j3.greyhead.org/components/com_chronoforms/exports/')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][file_name]', array(
      'type'      => 'text',
      'class'     => 'M',
      'label'     => l_('File name') ,
      'sublabel'  => l_('The name of the csv file.<br />You may include valid input values as {input_name}. If you leave this empty ChronoForms will create a name for you.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][post_file_name]', array(
      'type'      => 'text',
      'class'     => 'M',
      'label'     => l_('Form data name') ,
      'sublabel'  => l_('The name of the $form->data sub-array where data about the saved file will be saved.<br />If you leave this empty it will default to csv_export.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][delimiter]', array(
      'type'      => 'text',
      'class'     => 'SS',
      'label'     => l_('Delimiter') ,
      'sublabel'  => l_('The delimiter to be used for the CSV file,<br />
a single character only, defaults to comma ,.<br />Use ##tab## for a tab character.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][enclosure]', array(
      'type'      => 'text',
      'class'     => 'SS',
      'label'     => l_('Enclosure') ,
      'sublabel'  => l_('The enclosure to be used for the CSV file,<br />
a single character only,<br />defaults to double quote &dquo;')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][remove_breaks]', array(
      'type'      => 'checkbox',
      'class'     => 'SSS',
      'label'     => l_('Remove breaks') ,
      'sublabel'  => l_('If you check this box then any line-break or carriage returns in the data will be replaced with spaces.<br />This may be required if the file is to be opened in Excel.')
    ));
    echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="download-_XNX_" class="tab-pane">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    //echo "<div class='gh_title' ><h4>Download</h4></div>";
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][download_nosave]', array(
      'type'      => 'checkbox',
      'class'     => 'SSS',
      'label'     => l_('Do not save the file on the server') ,
      'sublabel'  => l_('If you check this box then the file will be created in the server memory and downloaded immediately.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][download_export]', array(
      'type'      => 'checkbox',
      'class'     => 'SSS',
      'label'     => l_('Immediate download') ,
      'sublabel'  => l_('If you check this box then the file will be downloaded immediately and your form or thank you page will not be displayed.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][download_mime_type]', array(
      'type'      => 'checkbox',
      'class'     => 'SSS',
      'label'     => l_('Set mime type to \'octet\'') ,
      'sublabel'  => l_('If you check this box then the file type will be set to \'application/octet-stream\' instead of \'text/csv\'.')
    ));
    echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="mysql-_XNX_" class="tab-pane">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    //echo "<div class='gh_title' ><h4>MySQL</h4></div>";
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][where]', array(
      'type'      => 'textarea',
      'class'     => 'XL',
      'rows'      => 4,
      'cols'      => 60,
      'label'     => l_('Where') ,
      'sublabel'  => l_('A valid CF/CCv5 WHERE clause to filter the results.<br />Please check the FAQs for the way to write this.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][order_by]', array(
      'type'      => 'text',
      'class'     => 'XL',
      'label'     => l_('Sort order') ,
      'sublabel'  => l_('The table column used for ordering.<br />If needed, include ASC or DESC to specify the sort direction.')
    ));
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][add_titles]', array(
      'type'      => 'checkbox',
      'class'     => 'SSS',
      'label'     => l_('Add titles') ,
      'sublabel'  => l_('If this box is checked then the column names will be added to the first row in the output file as titles')
    ));
    echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="columns-_XNX_" class="tab-pane">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    //echo "<div class='gh_title' ><h4>Columns</h4></div>";
    echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][columns]', array(
      'type'      => 'textarea',
      'class'     => 'XL',
      'rows'      => 7,
      'cols'      => 60,
      'label'     => l_('Column details') ,
      'sublabel'  => l_('For each database column to be exported add a new row using Column Title=column_name e.g. ID=id or User Name=name or Visible From=created_date. If you make any entry here then only columns included here will be exported; any \'included\' or \'excluded\' entries will be ignored.')
    ));
    /** echo \GCore\Helpers\Html::formLine('Form[extras][actions_config][_XNX_][excluded_columns]', array(
      'type'      => 'textarea',
      'class'     => 'XL',
      'rows'      => 7,
      'cols'      => 60,
      'label'     => l_('Exclude columns') ,
      'sublabel'  => l_('You can enter a comma separated list of column names *not* to be exported')
    )); */
    echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="help-_XNX_" class="tab-pane">
<?php
    echo \GCore\Helpers\Html::formSecStart();
    //echo "<div class='gh_title' ><h4>Help</h4></div>";
?>
<div>This action helps you export some or all of the entries from a database table into a CSV file that can be downloaded and used for other purposes.</div>
<h4>Date to be exported</h4>
<ul>
  <li><b>Table name</b>: Use this option to export directly from a database table. Select the Database table that you want to export data from. This is <i>required</i> unless you add a Data Path.</li>
  <li><b>Data Path</b>: Use this option to export data from the $form->data array e.g. data from a DB Multi-record Loader action. This is useful if you want to pre-process the data before exporting, or to export data from JOINed tables. Specify a path (or MODEL_ID) to the data in the $form->data array. </li>
</ul>
<h4>Export file</h4>
<ul>
  <li><b>Save Path</b>: Enter a valid full path to the folder where the csv file should be saved. You may use form inputs e.g. {input_name} in the path*. <br />Defaults to <tt><?php echo JPATH_SITE.'/components/com_chronoforms5/exports/{form_name}'; ?></tt></li>
  <li><b>File Name</b>: Enter a name for the file to be saved. You may use form inputs e.g. <tt>{input_name}</tt> in the file name*. The file suffix will be .csv, if this isn't set here it will be added after any existing suffix.<br />Defaults to <tt>csv_export_{$table_name}_{datetime}.csv</tt></li>
  <li>You can set values for the path or file name by creating form inputs with appropriate values. If <tt>{form_path}</tt> or <tt>{file_name}</tt> are set before this action in the form data or in a Custom Code action those values will replace any entries here.</li>
  <li><b>Form data name</b>: Enter a key name to be used to add the exported file info to the <tt>$form->files</tt> array if the file is to be saved on the server.</li>
  <li><b>Delimiter</b>: You can set a delimiter that will be placed between each value in a row. The default is a comma <tt>value1,value2</tt>. Use <tt>##tab##</tt> for a tab delimited file.</li>
  <li><b>Enclosure</b>: You can set an enclosure character that will be used to enclose individual values where necessary. The default is a double quote <tt>"value 1"</tt>.</li>
  <li>If the <b>Add Titles</b> box is checked the column names will be added to the first row of the CSV file as titles.</li>
  <li><b>Remove breaks</b>: If this box is checked then any carriage returns and line feeds in the data will be replaced with spaces. This may help export to Excel if your form uses textareas.</li>
</ul>
<h4>Downloads</h4>
<ul>
  <li>The checkboxes in this section allow you to control the way your file is downloaded.</li>
  <li>If you leave them all un-checked then the file will be saved to the server and you can use the entries added to the $form->data array to display or email a download link or to leave the file for future reference.</li>
  <li>If you check the <b>Immediate download</b> then the form will be downloaded when the either the form (if the action is in the On Load event) or the Thank You page loads. The file is still saved to the server but the download will act as a 'Show stopper' and no further actions will run.</li>
  <li>If you check the <b>No Save</b> checkbox then the form will be downloaded when the either the form (if the action is in the On Load event) or the Thank You page loads. The file is not saved to the server. In this case the file is created in memory if it is less than 5Mb,or in a temporary file if it is larger than this. This may be useful if you do not want to save the files, or if you have limited permission on the server.</li>
  <li>If you check the <b>Set mimetype to 'octet'</b> checkbox then the form will be downloaded with a type of 'application/octet-stream' instead of 'text/csv'. This may be useful if you want to prevent the file diplaying in the browser.</li>
</ul>
<h4>MySQL</h4>
This tab allows you to specify the records to be exported and the order of the export. Both use standard MySQL syntax. These only work if a Tablename is specified above as the data source.
<ul>
<li>The MySQL WHERE clause will take a valid WHERE clause to filter the result to be exported e.g. <tt>`id` &lt; 25</tt>. The word WHERE is optional. You can also use CF/CCv5 WHERE syntax - please check the FAQs for information on the syntax to use.</li>
<li>The MySQL ORDER BY clause will take a valid ORDER BY clause to sort the results to be exported e.g. <tt>`id` DESC</tt> The words ORDER BY are optional.</li>
</ul>
<div>Paths and file names can include the special <tt>{table_name}</tt>, <tt>{datetime}</tt> and <tt>{rand}</tt> values.
The value <tt>{datetime}</tt> inserts string in the form 'YmdHi' e.g. 201105101543;
<tt>{rand}</tt> inserts a six digit random number e.g. 857943.</div>
<h4>Columns</h4>
<div>This tab offers two different ways to specify the columns to be exported. You may leave all the boxes empty in which case all the columns will be exported in the order they appear in the table and the column names will be shown in the first row of the exported file.</div>
<ul>
  <li><!-- The Column details box overrides the Excluded list; if there are any entries here then any Excluded columns will be ignored. -->You can enter any number of rows here each of which specifies one column to be exported. Each row takes the form <tt>Column Title=column_name</tt>. The Column Title will be shown in the first row of the exported file and the columns will be exported in the order that they are shown here. You can also add valid MySQL clauses in the place of the column_name e.g. <tt>Column Title=`value` + 7</tt>. If a row has no <tt>=</tt> character then the entry will be used for both the Column Title and the Column Name e.g. <tt>Languages</tt>.<br />Note: take care with these entries, they are very flexible but are not verified and mistakes may break the export.</li>
  <!-- <li>In the Exclude Columns box you can enter a list of columns to be excluded. If the Include Columns box is empty all columns except these will be exported. If there are entries in the Included Columns box then any columns shown here will be removed from that list.</li>-->
</ul>
<h4>Results</h4>
<div>The Action generates several outputs: a file saved to the server in the specified folder; and three new form data items <tt>{csv_link}</tt>, <tt>{csv_count}</tt> and <tt>{csv_size}</tt>. These give you a full URL for the new file and the number of records exported. You can use these in later actions like Emails or Thank You messages to allow access to the file.</div>
<div>You can use the success (or fail) events to do whatever you need after the response is processed.</div>
<?php
      echo \GCore\Helpers\Html::formSecEnd();
?>
      </div>
      <div id="changelog-_XNX_" class="tab-pane">
<?php
echo \GCore\Helpers\Html::formSecStart();
//echo "<div class='gh_title' ><h4>Changelog</h4></div>";
?>
<div><span class='gh_date' >04 Jan 2012</span> : Added the ability to use form data in the WHERE box</div>
<div><span class='gh_date' >17 Feb 2012</span> : Fixed bug with titles not using custom delimiter and separator</div>
<div><span class='gh_date' >08 Apr 2012</span> : Replicated new functionality from CFv4 RC3: added title export option; option to get data from form data array; export of file info to $form->files array.</div>
<div><span class='gh_date' >08 Apr 2012</span> : Modified to use Constructor function.</div>
<div><span class='gh_date' >27 Sep 2012</span> : Added option to remove carriage return and newline characters for Excel exports.</div>
<div><span class='gh_date' >7 Jul 2014</span> : Converted to ChronoForms v5.</div>
  </div>
</div>
<?php
    echo \GCore\Helpers\Html::formSecEnd();
    echo \GCore\Helpers\Html::formEnd();
?>